﻿using System;
using System.Collections.Generic;
using System.Text;
using SpeedTestDll;

namespace SpeedTestExe
{
    public class Program
    {
        public static void Main(string[] args)
        {
            SpeedTest st = null;
            int oPort = SpeedTest.DEFAULT_PORT;
            string cliPrompt = "Type 'Q' to quit, 'S' for server state, 'C' for current config, 'L' clear console, 'Q' quit.";

            if (args.Length > 0)
            {
                Console.WriteLine("Found argument, assuming port number.");
                if (int.TryParse(args[0], out oPort) == true)
                {
                    Console.WriteLine("Using port number: " + oPort);
                    st = new SpeedTest(oPort, SpeedTest.DEFAULT_TITLE + " Service");
                }
                else
                {
                    Console.WriteLine("Using default port number: " + SpeedTest.DEFAULT_PORT);
                    st = new SpeedTest(SpeedTest.DEFAULT_PORT, SpeedTest.DEFAULT_TITLE + " Service");
                }
            }
            else
            {
                Console.WriteLine("Found NO arguments, using default port number: " + SpeedTest.DEFAULT_PORT);
                st = new SpeedTest(SpeedTest.DEFAULT_PORT, SpeedTest.DEFAULT_TITLE + " Service");
            }
            st.Start();

            Console.WriteLine(cliPrompt);
            string command = Console.ReadLine();
            while (command != null && command.ToLower() != "q")
            {
                if (command != null)
                {
                    if (command.ToLower() == "s")
                    {
                        st.PrintState();
                    }
                    else if (command.ToLower() == "c")
                    {
                        st.PrintConfig();
                    }
                    else if (command.ToLower() == "l")
                    {
                        Console.Clear();
                    }
                }

                Console.WriteLine(cliPrompt);
                command = Console.ReadLine();
            }

            st.CloseDebugFile();
            st.Stop();
            return;
        }
    }
}
